package us.blanshard.stubout;

import junit.framework.TestCase;

/**
 * A kind of test case that allows you to stub out existing classes with full or
 * partial replacements.
 * 
 * @author Luke Blanshard
 */
public class StubbingTestCase extends TestCase implements ReloadableTest
{
    public StubbingTestCase() {
    }

    public void beforeReloading() {
        // The default implementation does nothing
    }

    /**
     * Overrides the base implementation to divert the test class through the
     * stubber.
     */
    public void runBare() throws Throwable {
        Stubber.reloadAndRun(this);
    }

    public void runBareTest( String name ) throws Throwable {
        setName(name);
        super.runBare();
    }
}
